# How to use it!
# Simply save this script to a location in a windows device
# Open PowerShell an execute the script in the form of:  .\<script-name> http://xxx.xxx.xx.xx:xxx
# where http://xxx.xxx.xx.xx:xxx is the server to test


param(
    [string]$url
)

Write-Host @"
      
██╗     ██╗   ██╗███╗   ███╗██╗   ██╗
██║     ██║   ██║████╗ ████║██║   ██║
██║     ██║   ██║██╔████╔██║██║   ██║
██║     ██║   ██║██║╚██╔╝██║██║   ██║
███████╗╚██████╔╝██║ ╚═╝ ██║╚██████╔╝
╚══════╝ ╚═════╝ ╚═╝     ╚═╝ ╚═════╝

                                                       
"@

# Based on watchtowr-vs-ConnectWise_2024-02-21.py
# Sonny, watchTowr (sonny@watchTowr.com)

if (-not $url) {
    Write-Host "Error: Please provide a target URL." -ForegroundColor Red
    Exit
}

Write-Host "[*] Target Server: $url"

try {
    $response = Invoke-WebRequest -Uri "$url/SetupWizard.aspx/" -UseBasicParsing -TimeoutSec 15 -ErrorAction Stop
    if ($response.StatusCode -eq 200) {
        Write-Host "[*] ConnectWise ScreenConnect Installed"
    } else {
        Write-Host "[*] ConnectWise ScreenConnect Not Installed"
    }

    $response2 = Invoke-WebRequest -Uri "$url/SetupWizard.aspx/other" -UseBasicParsing -TimeoutSec 15 -ErrorAction Stop
    $viewgen_1 = $response.Content -match 'VIEWSTATEGENERATOR" value="([^"]+)"'
    
    if ($response2.StatusCode -eq 404) {
        Write-Host "[*] No Vulnerable"
    } else {
        if ($viewgen_1) {
            Write-Host "[!] Vulnerable. It's imperative that you patch your ConnectWise ScreenConnect instance" -ForegroundColor Red
            
        } else {
            Write-Host "[*] No Vulnerable." -ForegroundColor Green
        }
    }
    Write-Host ""
    Write-Host "[*] After patching, it's essential to acknowledge the possibility that "
    Write-Host "[*] your system might have been compromised during the vulnerable period."
    Write-Host ""
    Write-Host "[*] Lumu can help you to identify the presence of adversaries in your network."
    Write-Host "[*] Request free access at: https://lumu.io/msp-mssp/"
    Write-Host ""
} catch [System.Threading.Tasks.TaskCanceledException] {
    Write-Host "[*] Timeout occurred. ConnectWise ScreenConnect could not be detected." -ForegroundColor Yellow
} catch {
   Write-Host "[*] Error occurred: $($_.Exception.GetType().FullName)" -ForegroundColor Red
}
